/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef BITSET8_H_
#define BITSET8_H_

#define IsBitSet8Set(set8_, index_)     ((set8_[(index_)/8] & (1 << ((index_) & 0x7))) != 0)
#define IsBitSet8Cleared(set8_, index_) ((set8_[(index_)/8] & (1 << ((index_) & 0x7))) == 0)
#define SetBitSet8(set8_, index_)       do { \
    set8_[(index_)/8] |= (1 << ((index_) & 0x7)); \
} while (0);
#define ClearBitSet8(set8_, index_)     do { \
    set8_[(index_)/8] &= ~(1 << ((index_) & 0x7)); \
} while (0);

#endif /* BITSET8_H_ */
